% function mr = maximo_respuesta(observado,M,H,k1,k2,Nbloques);
%
%  Esta funcin se utiliza en costeinvrespfour para obtener el 
%  maximo de respuesta en una serie de bloques. 
%  Este mximo se utiliza (divido por un Juan's number)
%  para establecer el corte al hacer la inversa de la respuesta.
%
%   obsevado: imagen observada
%   M: tamao del bloque
%   H: funciones de interaccion (se obtiene en constantes_sin_continua)
%   k1: alpha (se obtiene en constantes_sin_continua)
%   k2: beta (se obtiene en constantes_sin_continua)
%   Nbloques: numero de bloques en los que obtener la respuesta
%
%
%
%

function mr = maximo_respuesta(observado,M,N,H,k1,k2,Nbloques);


[fil,col]=size(observado);


r=zeros(M);


filas = round(M/2 + rand(Nbloques,1)*(fil-M));
columnas = round(M/2 + rand(Nbloques,1)*(col-M));


for i=1:Nbloques
   
   bl=observado(filas(i)-M/2+1:filas(i)+M/2,columnas(i)-M/2+1:columnas(i)+M/2);

   r = r+ respuestafourier(bl,M,H,k1,k2);

end


respuestamedia = r/Nbloques;

mr = max(max(respuestamedia));
