% function [rest]=regu_modelo_ar4(Imobservada,b,lambdas,N,M,criterio_lambda,pinta);
%
%   Dada una imagen observada que ha pasado por un proceso de degradacin  representado
%   por PSF y a la que se ha aadido ruido, se intenta regularizar 
%   utilizando Wiener, a partir de una estimacin del espectro 
%   modelizando la seal mediante un modelo autorregresivo 
%   
%      
%      EJEMPLO                                                                        
%                                                                                     
%      [Irest_AR4]=regu_modelo_ar4(BlurredNoisy,PSF,lambdas,N,M,criterio_lambda,pinta);
%      


function [restaurada]=regu_modelo_ar4(Imobservada,b,lambdas,N,M,criterio_lambda,pinta);

[dummy,noiseest]=wiener2(Imobservada,[3 3]);


[fil,col]=size(Imobservada);


nver = fil/N;
nhor = col/N;

objetoparaoverlapping = rand(nver*M,nhor*M);


restaurada=rand([fil,col]); 

a=(M-N)/2;

Im2 = ampliaconborde(Imobservada,a);


nlamb=length(lambdas);

%lambdasoptimas=restaurada;



% El operador de blurring en el dominio de Fourier

B=freqz2(b,M,M);

B=ifftshift(B);



contadorfilas=0; 


for i=N/2:N:fil
   %fprintf('\nFila %d : ',i)
   contadorfilas = contadorfilas+1;
   contadorcolumnas = 0;

   for j=N/2:N:col
      %fprintf('%d, ',j)
      contadorcolumnas = contadorcolumnas + 1;
 
   
      observado=Im2(i+a-M/2+1:i+a+M/2,j+a-M/2+1:j+a+M/2);
      
      % bloqueor=Im3(i+a-M/2+1:i+a+M/2,j+a-M/2+1:j+a+M/2);
           
      [PSD,operador,coef_ar] = ajusta_bloque_ar4(observado);

      % Una vez tenemos el operador restauramos el bloque

      [sol]=restaura_bloque(observado,B,operador,M,N,lambdas,criterio_lambda);


      restaurada(i-N/2+1:i+N/2,j-N/2+1:j+N/2)=sol(a+1:a+N,a+1:a+N);
      
      if (pinta==1)
         imshow(restaurada,[0 256],'notruesize'),pause(0.2);
      end
           
      %lambdasoptimas(i-N/2+1:i+N/2,j-N/2+1:j+N/2)=lcurva.corner;

      objetoparaoverlapping((contadorfilas-1)*M+1:contadorfilas*M,(contadorcolumnas-1)*M+1:contadorcolumnas*M) = sol;
      

   end
end


restaurada = do_overlap(objetoparaoverlapping,M,N,8);


