% function [objeto]=regu_naive(Imobservada,b,N,M);
%
%   Dada una imagen observada que ha pasado por un proceso de degradacin  representado
%   por b y a la que se ha aadido ruido, se intenta regularizar utilizando la 
%   pseudoinversa en el dominio frecuencial. N es el tamao del bloque
%   y M es el tamao del bloque ms un borde, esto se hace para que los efectos de borde
%   no se vean en la solucin. 
%   Se devuelve tambien la imagen con los bloques sin procesar para hacer el overlapping
%
%      
%      EJEMPLO                                                                        
%                                                                                     
%      N = 16;                                                                          
%      M = 44;                                                                          
%      val = 0.1;
%
%      figure,[Irest]=regu_naive(BlurredNoisy,PSF,N,M);
%      


function [restaurada]=regu_naive(Imobservada,b,N,M);

[fil,col]=size(Imobservada);

objeto=rand([fil,col]); 

nver = fil/N;
nhor = col/N;

objetoparaoverlapping = rand(nver*M,nhor*N);


a=(M-N)/2;

Im2=ampliaconborde(Imobservada,a);


B=freqz2(b,M,M);

B=ifftshift(B);

BB = abs(B).^2;  
Bconj = conj(B); 

contadorfilas=1; 
  
for i=M/2:N:fil+a
   i
   contadorcolumnas=1;
   for j=M/2:N:col+a
    
      
 
      observado=Im2(i-M/2+1:i+M/2,j-M/2+1:j+M/2);

      cub=fft2(observado);

      Hinv=Bconj./BB;

      fftsol = Hinv.*cub;
         
      sol=real(ifft2(fftsol));
         
      solefectiva=sol(a+1:a+N,a+1:a+N);
      
      %objeto(i-a-N/2+1:i-a+N/2,j-a-N/2+1:j-a+N/2)=deraster(Objetos(:,pos),N,N);;
      
      objeto(i-a-N/2+1:i-a+N/2,j-a-N/2+1:j-a+N/2)=solefectiva;

      objetoparaoverlapping((contadorfilas-1)*M+1:contadorfilas*M,(contadorcolumnas-1)*M+1:contadorcolumnas*M) = sol;

      
      %figure(2),imshow(objeto,[0 256]),pause(0.1);
      %colormap(gray);imagesc(objeto),pause(0.1);
      contadorcolumnas=contadorcolumnas+1;
   end
   contadorfilas=contadorfilas+1;
end



restaurada = do_overlap(objetoparaoverlapping,M,N,4);
 
 
 
 
 