% function [objetooverlapping,restaurada,lambdasoptimas]=regu_perceptual(Imobservada,b,lambdas,N,M,H,k1,k2,umbral,criterio_lambda,pinta);
%
%   Dada una imagen observada que ha pasado por un proceso de degradacin  representado
%   por K y a la que se ha aadido ruido, se intenta regularizar usando el operador
%   de penalizacin L y un parmetro de regularizacin lambda. N es el tamao del bloque
%   y M es el tamao del bloque ms un borde, esto se hace para que los efectos de borde
%   no se vean en la solucin. 
%   pinta es un valor 0/1 para indicar si se muestra una figura de la evolucin de la solucin.
%     
%     
%     EJEMPLO:     
%     
%     N=16;
%     M=32;
%     
%     [H,k1,k2]=constantes2(fs,M);
%     
%     Nlambdas=70;
%     
%     lambdas=logspace(-2,2,Nlambdas);
%     
%     figure,[IrestPinv,lamboptPinv]=regu_perceptual(BlurredNoisy,PSF,lambdas ,N,M,H,k1,k2,umbral,2,1);





function [restaurada,lambdamedio]=regu_perceptual(Imobservada,b,lambdas,N,M,H,k1,k2,umbral,criterio_lambda,pinta);


[fil,col]=size(Imobservada);


nver = fil/N;
nhor = col/N;

objetoparaoverlapping = rand(nver*M,nhor*M);


restaurada=rand([fil,col]); 

a=(M-N)/2;

Im2=ampliaconborde(Imobservada,a);

[fil2,col2]=size(Im2);


nlamb=length(lambdas);


B=freqz2(b,M,M);

B=ifftshift(B);

BB = abs(B).^2;  
Bconj = conj(B); 

energB = sum(sum(abs(B).^2));


contadorfilas=0; 

valorlambda=0;

lam=[];

%r=zeros(M);
%
%contador = 1;
%for i=N/2:N:fil
%   for j=N/2:N:col
%      r = r+ respuestafourier(Im2(i+a-M/2+1:i+a+M/2,j+a-M/2+1:j+a+M/2),M,H,k1,k2);
%      contador = contador +1;
%   end
%end


%% Estimacin de la respuesta media en varios bloques


r=zeros(M);


Nbloques = 30;

filas = round(N/2 + rand(Nbloques,1)*(fil-N));
columnas = round(N/2 + rand(Nbloques,1)*(col-N));

lamb = 0; 

%R = [];

for i=1:Nbloques
   
   observado=Im2(filas(i)+a-M/2+1:filas(i)+a+M/2,columnas(i)+a-M/2+1:columnas(i)+a+M/2);

   r = r+ respuestafourier(observado,M,H,k1,k2);

   %R = [R r];
end


respuestamedia = r/Nbloques;

maximo = max(max(respuestamedia));
%media = mean(mean(R));


%% Fin estimacin de la respuesta media
 



%%% Estimacin del parametro de regularizacion 
%
%Nbloques = 25;
%
%filas = round(N/2 + rand(Nbloques,1)*(fil-N));
%columnas = round(N/2 + rand(Nbloques,1)*(col-N));
%
%lamb = 0; 
%
%for i=1:Nbloques
%   
%      observado=Im2(filas(i)+a-M/2+1:filas(i)+a+M/2,columnas(i)+a-M/2+1:columnas(i)+a+M/2);
%
%      F=costeinvrespfour(observado,M,H,k1,k2,maximo/umbral);
%            
%      [sol,lambda]=restaura_bloque(observado,B,F,M,N,lambdas,2);
%      
%      lamb = lamb + lambda;
%
%end
%
%lamb = lamb / Nbloques
%
%%% Fin estimacin del parametro de regularizacion 
% 



for i=N/2:N:fil
   %fprintf('\nFila %d : ',i)
   contadorfilas = contadorfilas+1;
   contadorcolumnas = 0;

   for j=N/2:N:col
      %fprintf('%d, ',j)
      contadorcolumnas = contadorcolumnas + 1;
            
      observado=Im2(i+a-M/2+1:i+a+M/2,j+a-M/2+1:j+a+M/2);

      %umb = umbral*mean2(Im2(i-N/2+1:i+N/2,j-N/2+1:j+N/2))/256

%      [dummy,varianzaruido] = wiener2(observado,[2 2]);      

%      if (mean2(observado)<128)
%         umbralito = umbral/2;
%      else
%         umbralito = umbral;
%      end

      F=costeinvrespfour(observado,M,H,k1,k2,maximo/umbral);

      [sol,lambd]=restaura_bloque(observado,B,F,M,N,lambdas,criterio_lambda);
      
      lam=[lam lambd];
 
      restaurada(i-N/2+1:i+N/2,j-N/2+1:j+N/2)=sol(a+1:a+N,a+1:a+N);
      
      
      if (pinta == true)
         figure(500),imshow(restaurada,[0 256],'notruesize'),pause(0.2);
      end
           
      objetoparaoverlapping((contadorfilas-1)*M+1:contadorfilas*M,(contadorcolumnas-1)*M+1:contadorcolumnas*M) = sol;
      

   end
end

lambdamedio = mean(lam);

restaurada = do_overlap(objetoparaoverlapping,M,N,8);

 
 
 
 
 
 
 
 
 
 