% function [sol]=restaura_bloque(observado,B,F,lambdas,criterio_lambda)
%
%   observado:   bloque
%   B:           operador de blurring en Fourier
%   F:           operador de regularizacion en Fourier
%   lambdas:     vector con los valores de lambda
%   criterio_lambda:  metodo para seleccionar el lambda
%
%   Devuelve
%   sol:         bloque restaurado


function [sol,valorlambda]=restaura_bloque(observado,B,F,M,N,lambdas,criterio_lambda)

M = size(observado,1);

nlamb=length(lambdas);

vectorsol = rand(nlamb*M,M);


[dummy,varianzaruido] = wiener2(observado,[2 2]);      


energB = sum(sum(abs(B).^2));

Bconj = conj(B);

BB = B.*Bconj; 


%guardaF = fftshift(F);

%F = abs(F)/max(max(abs(F)));

operador = formatea_operador(F);

F = operador;

energF = sum(sum(abs(F).^2));

% Hacemos que F tenga la misma energia que B

if (energF==0)
   F = sqrt(energB)*F;
else
   F = sqrt(energB)*F/sqrt(energF);
end


FF = F.*conj(F);

%%%% SUAVIZADO DEL MARCO

ang = linspace(0,pi/2,5);
v = [reverse(cos(ang)) ones(1,M-2*5) cos(ang)];
pesos = v'*v;

observado = observado.*pesos + (1-pesos).*mean(mean(observado));


%% FIN SUAVIZADO

cub=fft2(observado);

espdeg = cub;

% Soluciones para cada lambda

x=zeros(nlamb,1);
y=zeros(nlamb,1); 


for k=1:nlamb 
   
   lambda=lambdas(k);            
   

   Hinv=Bconj./( BB + lambda^2*FF);
   
     
   fftsol = Hinv.*cub;


%   solu = real(ifft2(fftsol));
%   
%   minimos = min(min(solu));
%   maximos = max(max(solu));
%   
%   minimoo = min(min(observado));
%   maximoo = max(max(observado));
%   
%   solu = (maximoo - minimoo)/(maximos-minimos)*(solu-minimos)+minimoo;
%   
%   fftsol = fft2(solu);
%   
   
   
   
   
   %norma del residual

   rF = B.*fftsol - cub;

   x(k) = norm(rF(:))/M;

   
   %norma del operador sobre la solucion
   
   pF = F.*fftsol;
   
   y(k)=norm(pF(:))/M;

   %figure,colormap(gray);imshow(real(ifft2(fftsol)),[0 256],'notruesize');title(num2str([x(k) y(k)]));pause;close;
   
end

if (nlamb==1) 
   valorlambda=lambda;
else
   valorlambda = seleccion_lambda(x,y,lambdas,varianzaruido,criterio_lambda);
end

if (length(valorlambda)>1)
   valorlambda = 2;
end

distancias = abs(lambdas-valorlambda);
pos = find(distancias==min(distancias));
pos = pos(1);

%figure,plot(x,y,'.-');hold on;plot(x(pos),y(pos),'r*');pause;close

Hinv=Bconj./( BB + valorlambda^2*FF);
   

%figure,mesh(abs(fftshift(Hinv))),pause(0.5),close
   
sol=real(ifft2(Hinv.*cub));



