% function lamb=estima_lambda(Imobservada,B,lambdas,M,F,Nbloques);
%
%   Dada una imagen observada que ha pasado por un proceso de degradacin  representado
%   por K y a la que se ha aadido ruido, se intenta regularizar usando el operador
%   de penalizacin F y parmetros de regularizacin lambdas. N es el tamao del bloque
%   y M es el tamao del bloque ms un borde, esto se hace para que los efectos de borde
%   no se vean en la solucin. 
%   Se devuelve tambien la imagen con los bloques sin procesar para hacer el overlapping
%
%      
%      EJEMPLO                                                                        
%                                                                                     
%      N=16;                                                                          
%      M=44;                                                                          
%                                                                                     
%      Nlambdas=70;                                                                   
%                                                                                     
%      lambdas=logspace(-2,2,Nlambdas);                                               
%                                                                                     
%                                                                                     
%      operador=fft2(filt2dsegder,M,M);                                               
%                                                                                     
%      figure,lamb=estima_lambda(BlurredNoisy,PSF,lambdas,M,operador,Nbloques);
%      


function lamb=estima_lambda(Imobservada,B,lambdas,M,N,F,Nbloques);

[fil,col]=size(Imobservada);
 

a=(M-N)/2;

Im2=ampliaconborde(Imobservada,a);


filas = round(N/2 + rand(Nbloques,1)*(fil-N));
columnas = round(N/2 + rand(Nbloques,1)*(col-N));

filas,columnas

lamb = 0;
 

for i=1:Nbloques

   
      observado=Im2(filas(i)+a-M/2+1:filas(i)+a+M/2,columnas(i)+a-M/2+1:columnas(i)+a+M/2);
      
     % bloqueor=Im3(i+a-M/2+1:i+a+M/2,j+a-M/2+1:j+a+M/2);
           

      
      [sol,lambda]=restaura_bloque(observado,B,F,M,N,lambdas,2);
      
      lamb = lamb + lambda;
      
end

lamb = lamb / Nbloques;
 
 
 
 