function regu=max_incr_pend_Lcurva(x,y,lambdas)

% lambda=max_incr_pend_Lcurva(r,Lx,lambdas)
%
%       Esta funcin determina el punto de maxima variacion en el angulo
%       que forma la pendiente en los puntos de la L-curva


if (size(x,1)<size(x,2))
   x=x';
   y=y';
end


xx=linspace(min(x),max(x),25000);


% Este es el incremento de x

h= xx(2)-xx(1);

% Interpolamos los valores de y en los puntos xx


try
yy = interp1(x,y,xx,'cubic');


% Calculamos la primera derivada (pendiente de la curva en cada punto)
 
pendientes = diff(yy)/h;

% El angulo en grados es

angulos = atan(pendientes)*180/pi;


angulos = (angulos<=-(85))*(-85) + (angulos>=(-10))*(-10) + angulos.*(angulos>(-85) & angulos<(-10)); 

% Buscamos la diferencia en grados 

a=diff(angulos);

% Buscamos donde se produce la maxima variacion

mc=find(a==max(max(a)));

regu = interp1(x,lambdas',xx(mc),'cubic');

catch
regu = 2;
end