% funcion p = pesos_overlapping(ov);
%
%    Devuelve una matriz de pesos de tamao 32x32 para realizar el overlapping
%    entre bloques.
%    El tamao en pixels del overlapping se pasa como un parametro
%


function p = pesos_overlapping(M,N,ov);

p = zeros(M);

tam =N+ov*2;

centro = ones(tam);

v = linspace(.9,.1,2*ov);

vr = repmat(v,tam-4*ov,1);
vl = repmat(reverse(v),tam-4*ov,1);
vb = repmat(v',1,tam-4*ov);
vt = repmat(reverse(v)',1,tam-4*ov);

esquinabr = simrev(v);
esquinatr = flipud(esquinabr);

esquinabl = fliplr(esquinabr);
esquinatl = fliplr(esquinatr);

centro(1:2*ov,1:2*ov) = esquinatl;
centro(1:2*ov,2*ov+1:tam-2*ov) = vt;
centro(1:2*ov,N+1:N+2*ov) = esquinatr;

centro(2*ov+1:tam-2*ov,1:2*ov) = vl;
centro(2*ov+1:tam-2*ov,tam-2*ov+1:tam) = vr;

centro(tam-2*ov+1:tam,1:2*ov) = esquinabl;
centro(tam-2*ov+1:tam,2*ov+1:tam-2*ov) = vb;
centro(tam-2*ov+1:tam,tam-2*ov+1:tam) = esquinabr;


p((M-tam)/2+1:M-(M-tam)/2,(M-tam)/2+1:M-(M-tam)/2)=centro;
