clc;
echo off;

%% LOAD IMAGE

disp('Loading image');

load barbara256;
figure;
imshow(Im/255);
title('Original image');

%% DEGRADE IMAGE

disp('Degrading image (almost denoising)');

% Cutoff frequency of the blurring operator
fc = 24;
Val_min = 0.001;

% Frecuency band of the noise 
% In this case: white noise
lim_frec = [0 3];

% Noise variance
vari = 400;

[Id,PSF,H,noise,Blurred]=degrada2(Im,fc,Val_min,lim_frec,vari);
figure;
imshow(Id/255);
title(['Degraded image (f_c = ' num2str(fc) ',\sigma^2 = ' num2str(vari) ')']);

disp('Press any key...');
pause;



disp('SENSITIVITY TO LAMBDA');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%% SENSITIVITY TO LAMBDA  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%% RESTORE IMAGE: PERCEPTUAL OPERATOR

Nlambdas = 1;
lambdas = 1;

disp(['Restoring image using PERCEPTUAL (' num2str(Nlambdas) ' values of lambda)']);


imrper=restaura2(Id,'PER',PSF,lambdas);

figure;
imshow(imrper/255);
title(['Perceptual, \lambda=' num2str(lambdas)]);




%% RESTORE IMAGE: PERCEPTUAL OPERATOR

Nlambdas = 1;
lambdas = 2;

disp(['Restoring image using PERCEPTUAL (' num2str(Nlambdas) ' values of lambda)']);


imrper=restaura2(Id,'PER',PSF,lambdas);

figure;
imshow(imrper/255);
title(['Perceptual, \lambda=' num2str(lambdas)]);





%% RESTORE IMAGE: PERCEPTUAL OPERATOR

Nlambdas = 1;
lambdas = 4;

disp(['Restoring image using PERCEPTUAL (' num2str(Nlambdas) ' values of lambda)']);


imrper=restaura2(Id,'PER',PSF,lambdas);

figure;
imshow(imrper/255);
title(['Perceptual, \lambda=' num2str(lambdas)]);



%% RESTORE IMAGE: PERCEPTUAL OPERATOR

Nlambdas = 1;
lambdas = 6;

disp(['Restoring image using PERCEPTUAL (' num2str(Nlambdas) ' values of lambda)']);


imrper=restaura2(Id,'PER',PSF,lambdas);

figure;
imshow(imrper/255);
title(['Perceptual, \lambda=' num2str(lambdas)]);



%% RESTORE IMAGE: PERCEPTUAL OPERATOR

Nlambdas = 1;
lambdas = 10;

disp(['Restoring image using PERCEPTUAL (' num2str(Nlambdas) ' values of lambda)']);


imrper=restaura2(Id,'PER',PSF,lambdas);

figure;
imshow(imrper/255);
title(['Perceptual, \lambda=' num2str(lambdas)]);





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%% SENSITIVITY TO LAMBDA  AR12 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%% RESTORE IMAGE: AR12 OPERATOR

Nlambdas = 1;
lambdas = 1;

disp(['Restoring image using AR12 (' num2str(Nlambdas) ' values of lambda)']);


imrar12=restaura2(Id,'AR12',PSF,lambdas);

figure;
imshow(imrar12/255);
title(['AR12, \lambda=' num2str(lambdas)]);



%% RESTORE IMAGE: AR12 OPERATOR

Nlambdas = 1;
lambdas = 2;

disp(['Restoring image using AR12 (' num2str(Nlambdas) ' values of lambda)']);


imrar12=restaura2(Id,'AR12',PSF,lambdas);

figure;
imshow(imrar12/255);
title(['AR12, \lambda=' num2str(lambdas)]);




%% RESTORE IMAGE: AR12 OPERATOR

Nlambdas = 1;
lambdas = 4;

disp(['Restoring image using AR12 (' num2str(Nlambdas) ' values of lambda)']);


imrar12=restaura2(Id,'AR12',PSF,lambdas);

figure;
imshow(imrar12/255);
title(['AR12, \lambda=' num2str(lambdas)]);



%% RESTORE IMAGE: AR8 OPERATOR

Nlambdas = 1;
lambdas = 6;

disp(['Restoring image using AR12 (' num2str(Nlambdas) ' values of lambda)']);


imrar8=restaura2(Id,'AR12',PSF,lambdas);

figure;
imshow(imrar12/255);
title(['AR12, \lambda=' num2str(lambdas)]);




%% RESTORE IMAGE: AR12 OPERATOR

Nlambdas = 1;
lambdas = 10;

disp(['Restoring image using AR12 (' num2str(Nlambdas) ' values of lambda)']);


imrar8=restaura2(Id,'AR12',PSF,lambdas);

figure;
imshow(imrar12/255);
title(['AR12, \lambda=' num2str(lambdas)]);


