clc;
echo off;

if (isempty(who('Id')))
   disp('To run this script there should be an image named Id in the workspace.');
   disp('Id should contain the degraded image.');
   return;
end

%% IT IS ASSUMED THAT THE DEGRADED IMAGE IS NAMED Id

% Cutoff frequency of the blurring operator
fc = 45;
Val_min = 0.001;

% Frecuency band of the noise 
% In this case: white noise
lim_frec = [0 3];

% Noise variance
vari = 400;

[W,PSF,H,noise,Blurred]=degrada2(rand(256),fc,Val_min,lim_frec,vari);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


Nlambdas = 60;

lambdas = logspace(-4,3,Nlambdas);

%% RESTORE IMAGE: SECOND DERIVATIVE OPERATOR

disp(['Restoring image using L2 (' num2str(Nlambdas) ' values of lambda)']);

imrl2=restaura2(Id,'L2',PSF,lambdas);

figure;
imshow(imrl2/255);
title('Restored (L2)');

disp('Press any key...');
pause;


%% RESTORE IMAGE: CSF OPERATOR

disp(['Restoring image using CSF (' num2str(Nlambdas) ' values of lambda)']);

imrcsf=restaura2(Id,'CSF',PSF,lambdas);

figure;
imshow(imrcsf/255);
title('Restored (CSF)');

disp('Press any key...');
pause;


%% RESTORE IMAGE: AR4 OPERATOR


disp(['Restoring image using AR4 (' num2str(Nlambdas) ' values of lambda)']);

imrar4=restaura2(Id,'AR4',PSF,lambdas);

figure;
imshow(imrar4/255);
title('Restored (AR4)');

disp('Press any key...');
pause;



%% RESTORE IMAGE: AR8 OPERATOR


disp(['Restoring image using AR8 (' num2str(Nlambdas) ' values of lambda)']);

imrar8=restaura2(Id,'AR8',PSF,lambdas);

figure;
imshow(imrar8/255);
title('Restored (AR8)');

disp('Press any key...');
pause;




%% RESTORE IMAGE: AR12 OPERATOR


disp(['Restoring image using AR12 (' num2str(Nlambdas) ' values of lambda)']);

imrar12=restaura2(Id,'AR12',PSF,lambdas);

figure;
imshow(imrar12/255);
title('Restored (AR12)');

disp('Press any key...');
pause;



%% RESTORE IMAGE: PERCEPTUAL OPERATOR


disp(['Restoring image using PERCEPTUAL (' num2str(Nlambdas) ' values of lambda)']);

imrper=restaura2(Id,'PER',PSF,lambdas);

figure;
imshow(imrper/255);
title('Restored (PERCEPTUAL)');


