clc;
clear;

load barbara256.mat
disp('Image loaded')

% Aproximated values for Csvm & sigma
C       = 3000;
sigma   = 4;
epsilon = 2;
load Epsilon_profile_Gaussian.mat

% Degraded image
Var     = 400;
Idegraded = Im + sqrt(Var)*randn(256);
PP  = perfil_eps*sqrt(Var);
disp(['Image degraded with variance ' num2str(Var)])

% Restore image
disp('Restoring Image ...')
Irestored = restoring_image_SVM(Idegraded,epsilon,C,sigma,PP);
disp('Done!')

% Compute results
RMSE = sqrt(mean((Im(:)-Irestored(:)).^2))
PSNR = psnr(Im,Irestored)

% Show images
figure,imshow(Idegraded/255),title('Degraded Image')
figure,imshow(Irestored/255),title('SVR Restored Image')

