clc;
clear;

load barbara256.mat
disp('Image loaded')

% Aproximated values for Csvm & sigma
C       = 3000;
sigma   = 1;
epsilon = 1.7;
load Epsilon_profile_JPEG_Q7.mat

% Degraded image
Quality = 7;
imwrite(Im/255,['./temporal_jpeg.jpg'],'Quality',Quality);
Idegraded = double(imread('temporal_jpeg.jpg'));
delete('./temporal_jpeg.jpg')
disp(['JPEG Image with quality ' num2str(Quality)])

% Restore image
disp('Restoring Image ...')
Irestored = restoring_image_SVM(Idegraded,epsilon,C,sigma,perfil_eps);
disp('Done!')

% Compute results
RMSE = sqrt(mean((Im(:)-Irestored(:)).^2))
PSNR = psnr(Im,Irestored)

% Show images
figure,imshow(Idegraded/255),title('Degraded Image')
figure,imshow(Irestored/255),title('SVR Restored Image')

