% Script que 'limpia' una imagen mediante la tecnica del hard-thresholding
% pero en el dominio wavelet steerable de 4 escalas 8 orientaciones
%
% El landa (aqui llamado res) se ha ajustado para 100 imagenes ajustado 
% para varianzas 200 y 400, no sera un valor optimo para varianzas muy distintas a estas
%
% USO: IMM=hard_steerable(Im2,Var)
% donde Var es la varianza del ruido (gausiano)

function IMM=hard_steerable(Im2,Var)
 
res= 0.7+sqrt(Var)*0.018;

[pyr,ind]=buildsfpyr(Im2,4,7);
pyr2=abs(pyr);
pyr_sg=sign(pyr);
load indices_epsilon_4esc_8ori
indices=indices*sqrt(Var)/sqrt(400);


res=res*indices;
P2=zeros(size(pyr2));

for k=1:length(pyr2)-255
    if pyr2(k)>res(k)
        P2(k)=pyr2(k)-res(k);
    else
        P2(k)=0;
    end
end
P2(1:256*256-1)=zeros;
P2(end-255:end)=pyr(end-255:end);
PYR3=P2.*pyr_sg;
%
IMM=reconsfpyr(PYR3,ind);
