% Computes the Kernel matrix
%
% K = kernelgauss2Dsteerable(L,a,b,alfa)
%
%  Example:
%
%    L = 16;% block size
%    a = 2; % width
%    b = 1; % height
%    alfa = 70; % orientation (horizontal = 0; vertical = 90);
%

function K=kernelgauss2Dsteerable(L,a,b,alfa)

[x,y]=meshgrid([1:L],[1:L]);

s=sin(-alfa*pi/180);
c=cos(-alfa*pi/180);
cc=c^2;ss=s^2;aa=a^2;bb=b^2;

i=1;
for xm=1:L
    for ym=1:L
        g=exp(-pi*(2*(bb-aa)*c*s*(x-xm).*(y-ym)+(bb*cc+aa*ss)*(x-xm).^2+(aa*cc+bb*ss)*(y-ym).^2)/(aa*bb));
        g=g/max(max(g));
        K(i,:)=g(:)';
        i=i+1;
    end
end
