% FUNCION QUE REALIZA LA LIMPIEZA DE RUIDO GAUSIANO DE FORMA BAYESIANA COMO
% SE EXPLICA EN SIMONCELLI '99 "Bayesian denoising of visual images in the wavelet domain." 
% Se le pasan la imagen Im y la varianza del ruido gausiano Var
% USO: [IMM,S,P]=Soft_B_denois_4_todo_numerico(Im2,Var)
% Im2 es la imagen ruidosa; Var es la varianza del ruido gausiano
% IMM es la imagen limpiada; S y P son los valores que definen las distribuciones de
% probabiliad para cada orientacion y escala

function [IMM,S,P]=Soft_B_denois_4_todo_numerico(Im2,Var)
% Imagen


S=[]
ImDeg = Im2;
desviacion=sqrt(Var);
% Se realiza la transformada Wavelet
NW=4;
[pyrDeg,indDeg]=buildwpyr(double(ImDeg),NW);

orientaciones=cell(3,1);

orientaciones{1}='H';
orientaciones{2}='V';
orientaciones{3}='D';

estimado=zeros(size(pyrDeg));

cont=1;

for escala=1:NW
    escala
    for ori=1:3
        orientacion=orientaciones{ori}
        
        switch lower(orientacion)
            case 'h'
                sub=1;
            case 'v'
                sub=2;
            case 'd'
                sub=3;
        end
        
        % A marginal_2 deberia de poder pasarsele NW (internamente lo hace con NW=4)
        % esta funcion extrae en subbandacrop la subbanda de escala y
        % orientacion determinados, pero elimina los coeficientes con
        % probabilidad despreciable
        [histograma,valores,subbanda,subbandacrop]=marginal_2(Im2,escala,orientacion,256);
%         %este bucle busca los valores de s y p que minimizan el (- likelihood) es decir maximizan el likelihood 
        QQ=1
        for s=logspace(-1,2,25)
            for p=linspace(0.35,1.45,25)
                l=likelihooddegradadaB([s p],subbanda,Var);
                MM(1,QQ)=s;
                MM(2,QQ)=p;
                MM(3,QQ)=l;
                escala
                QQ=QQ+1                    
            end
        end
        [MN,IN]=min(MM(3,:));
        S(escala,ori)=MM(1,IN);
        P(escala,ori)=MM(2,IN);
        %%% Hasta aqui la prediccion de los coeficientes de la distribucion
        %%% de la imagen original
        
        %%% Ahora extraemos la subbanda completa
        pyrsubDeg = wpyrBand(pyrDeg, indDeg, escala, sub);
        pyrsubDeg = pyrsubDeg(:);
        
        
        lookup = [];
        % Aqui se hace la estimacion de las funciones que van a predecir los coeficientes originales 
        % (pagina 5 figure 3 de simoncelli '99)
        pasox=0.5;
        rango = [round(min(pyrsubDeg))-30:pasox:round(max(pyrsubDeg))+30];
        num2=[];den2=[];
        for valor=rango
            num = sum(pasox.*blsnum(rango,valor,S(escala,ori),P(escala,ori),desviacion));
            denom = sum(pasox.*blsdenom(rango,valor,S(escala,ori),P(escala,ori),desviacion));
            num2=[num2 num];
            den2=[den2 denom];
            lookup = [lookup num/denom];
        end
        
        % Aqui se hace la estimacion de los coeficientes originales 
        
        for indice=1:length(pyrsubDeg)
            estimado(cont) = interp1(rango,lookup,pyrsubDeg(indice));
            cont=cont+1;
        end
        
        
    end
end

estimado(cont:end) = pyrDeg(cont:end);

IMM=reconWpyr(estimado,indDeg);



