% FUNCION QUE REALIZA LA LIMPIEZA DE RUIDO GAUSIANO DE FORMA BAYESIANA COMO
% SE EXPLICA EN SIMONCELLI '99 "Bayesian denoising of visual images in the wavelet domain." 
% Se le pasan la imagen Im y la varianza del ruido gausiano Var
% USO: [IMM,S,P]=Soft_B_denois_steerable(Im2,Var)
% Im2 es la imagen ruidosa; Var es la varianza del ruido gausiano
% IMM es la imagen limpiada; S y P son los valores que definen las distribuciones de
% probabiliad para cada orientacion y escala

function [IMM,S,P]=Soft_B_denois_steerable(Im2,Var)
% Imagen

ImDeg = Im2;
desviacion=sqrt(Var);
% Se realiza la transformada Wavelet
NW=4;
[pyrDeg,indDeg]=buildsfpyr(double(ImDeg),4,7);
pyrEst=zeros(size(pyrDeg));
% estos indices son para imagenes de 256x256 
% DWT 4 escalas 8 orientaciones filtros por defecto
% Varianza del ruido 400
load indices_epsilon_4esc_8ori
indices=indices*sqrt(Var)/sqrt(400);

for escala=1:NW
    
    for ori=1:8
        [escala ori]
%                
%         BAND_NUM=1+ori+(escala-1)*8;
%         subbanda=pyrBand(pyrDeg, indDeg, BAND_NUM);
        PP=[];
        A=[];
        for i=1:2^(9-escala)
            for j=1:2^(9-escala)
                pp=pos_s_pyr([escala ori i j],indDeg);
                A(i,j)=pyrDeg(pp);
                PP(i,j)=pp;
            end
        end
        subbanda=A;

%         %este bucle busca los valores de s y p que minimizan el (- likelihood) es decir maximizan el likelihood 
        QQ=1;
        MM=zeros(3,15*15);
        for s=logspace(-1.5,2.5,25)
            for p=linspace(0.35,2,20)
                l=likelihooddegradadaB([s p],subbanda,indices(PP(1,1))^2);
                MM(1,QQ)=s;
                MM(2,QQ)=p;
                MM(3,QQ)=l;
                QQ=QQ+1;                    
            end
        end
        [MN,IN]=min(MM(3,:));
        S(escala,ori)=MM(1,IN);
        P(escala,ori)=MM(2,IN);
        %%% Hasta aqui la prediccion de los coeficientes de la distribucion
        %%% de la imagen original
        
        pyrsubDeg = subbanda(:);
                
        lookup = [];
        % Aqui se hace la estimacion de las funciones que van a predecir los coeficientes originales 
        % (pagina 5 figure 3 de simoncelli '99)
        pasox=0.5;
        rango = [round(min(pyrsubDeg))-30:pasox:round(max(pyrsubDeg))+30];
        num2=[];den2=[];
        for valor=rango
            num = sum(pasox.*blsnum(rango,valor,S(escala,ori),P(escala,ori),desviacion));
            denom = sum(pasox.*blsdenom(rango,valor,S(escala,ori),P(escala,ori),desviacion));
            num2=[num2 num];
            den2=[den2 denom];
            lookup = [lookup num/denom];
        end
        
        % Aqui se hace la estimacion de los coeficientes originales 
        estimado=zeros(size(pyrsubDeg));
        for indice=1:length(pyrsubDeg)
            estimado(indice) = interp1(rango,lookup,pyrsubDeg(indice));
        end
        
        BB=reshape(estimado,2^(9-escala),2^(9-escala));
        pyrEst(PP)=BB;
                
    end
end

pyrEst(length(pyrDeg)-32*32+1:length(pyrDeg)) = pyrDeg(length(pyrDeg)-32*32+1:length(pyrDeg));

IMM=reconsfpyr(pyrEst,indDeg);



