% [histograma,valores,subbanda]=marginal(Im,escala,orientacion,bins);
% MODIFICACION DE MARGINAL PARA PODER METERLE UNA IMAGEN

%   [histograma,valores,subbanda,subbandacrop]=marginal(imagenes,1,'H',256);
%      imagenes es un cell con los nombres de las imagenes
%
%   histograma: ordenada del histograma de los coefs wavelet 
%   valores:    abscisa del histograma (valores de los coeficientes donde estn centrados los bins) 
%   subbanda:   valores extraidos de la subbanda
%   subbandacrop: valores extraidos de la subbanda quitando outlayers

function [histograma,valores,subbanda,subbandacrop]=marginal_2(Im,escala,orientacion,bins);

switch lower(orientacion)
   case 'h'
      sub=1;
   case 'v'
      sub=2;
   case 'd'
      sub=3;
end

subbanda=[];

   [pyr,ind]=buildwpyr(double(Im),4);
   pyrsub = wpyrBand(pyr, ind, escala, sub);
   pyrsub = pyrsub(:);
   subbanda = [subbanda; pyrsub];

[histograma,valores] = hist(subbanda,256);
histograma = histograma/sum(histograma);

% Voy a tomar solo los puntos representativos 

cdf = cumsum(histograma);

ind1 = find(cdf>=0.005);
ind1 = ind1(1);

ind2 = find(cdf<=0.995);
ind2 = ind2(end);

subbandacrop = subbanda(subbanda>valores(ind1) & subbanda<valores(ind2));

[histograma,valores] = hist(subbanda,256);
histograma = histograma/sum(histograma);